#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <errno.h>
extern int errno;
#include "ndelay.h"
#include "conn.h"

static void addr_sin(a,sin)
struct conn_addr *a;
struct sockaddr_in *sin;
{
 unsigned char *x;
 x = (unsigned char *) &sin->sin_addr;
 a->h1 = 255 & (int) *x;
 a->h2 = 255 & (int) *++x;
 a->h3 = 255 & (int) *++x;
 a->h4 = 255 & (int) *++x;
 x = (unsigned char *) &sin->sin_port;
 a->p1 = 255 & (int) *x;
 a->p2 = 255 & (int) *++x;
}

static void sin_addr(sin,a)
struct sockaddr_in *sin;
struct conn_addr *a;
{
 unsigned char *x;
 x = (unsigned char *) &sin->sin_addr;
 *x = a->h1;
 *++x = a->h2;
 *++x = a->h3;
 *++x = a->h4;
 x = (unsigned char *) &sin->sin_port;
 *x = a->p1;
 *++x = a->p2;
}

int conn_us(fd,a)
int fd;
struct conn_addr *a;
{
 struct sockaddr_in sin;
 int addrlen;

 addrlen = sizeof(sin);
 if (getsockname(fd,(struct sockaddr *) &sin,&addrlen) == -1)
   return -1;
 addr_sin(a,&sin);
 return 0;
}

int conn_them(fd,a)
int fd;
struct conn_addr *a;
{
 struct sockaddr_in sin;
 int addrlen;

 addrlen = sizeof(sin);
 if (getpeername(fd,(struct sockaddr *) &sin,&addrlen) == -1)
   return -1;
 addr_sin(a,&sin);
 return 0;
}

int conn_server(a)
struct conn_addr *a;
{
 int fd;
 int i;
 struct sockaddr_in sin;

 a->p1 = a->p2 = 0; /*XXX*/
 for (i = 0;i < sizeof(sin);++i) ((char *) &sin)[i] = 0;
 sin_addr(&sin,a);
 sin.sin_family = AF_INET;
 fd = socket(AF_INET,SOCK_STREAM,0);
 if (fd == -1) return -1;
 if (ndelay(fd) == -1) { close(fd); return -1; }
 if (bind(fd,(struct sockaddr *) &sin,sizeof(sin)) == -1) { close(fd); return -1; }
 if (listen(fd,2) == -1) { close(fd); return -1; }
 if (conn_us(fd,a) == -1) { close(fd); return -1; }
 return fd;
}

int conn_accept(fd,a)
int fd;
struct conn_addr *a;
{
 int len;
 struct sockaddr_in sin;
 int s;

 len = sizeof(sin);
 s = accept(fd,(struct sockaddr *) &sin,&len);
 if (s == -1)
   return -1;
 if (ndelay(s) == -1) { close(s); return -1; }
 addr_sin(a,&sin);
 return s;
}

int conn_connect(from,to)
struct conn_addr *from;
struct conn_addr *to;
{
 int fd;
 int i;
 struct sockaddr_in sin;

 for (i = 0;i < sizeof(sin);++i) ((char *) &sin)[i] = 0;
 sin_addr(&sin,from);
 sin.sin_family = AF_INET;
 fd = socket(AF_INET,SOCK_STREAM,0);
 if (fd == -1) return -1;
 i = 1;
 if (setsockopt(fd,SOL_SOCKET,SO_REUSEADDR,(char *) &i,sizeof(i)) == -1) { close(fd); return -1; }
 if (ndelay(fd) == -1) { close(fd); return -1; }
 if (bind(fd,(struct sockaddr *) &sin,sizeof(sin)) == -1) { close(fd); return -1; }
 sin_addr(&sin,to);
 if (connect(fd,(struct sockaddr *) &sin,sizeof(sin)) == -1)
   if ((errno != EWOULDBLOCK) && (errno != EINPROGRESS))
    {
     close(fd);
     return -1;
    }
 return fd;
}

int conn_undostupidity(fd)
int fd;
{
 int i;
 i = 1;
 return setsockopt(fd,SOL_SOCKET,SO_OOBINLINE,(char *) &i,sizeof(i));
}
