#include "doit.h"
#include "ftp.h"
#include "err.h"

static struct { void (*fun)(); char *text; } ftpcmd[] = {
  { err_user, "user" }
, { err_noop, "noop" }
, { ftp_quit, "quit" }
, { ftp_port, "port" }
, { ftp_pasv, "pasv" }
, { ftp_retr, "retr" }
, { ftp_list, "list" }
, { ftp_nlst, "nlst" }
, { err_help, "help" }
, { ftp_stru, "stru" }
, { ftp_mode, "mode" }
, { ftp_type, "type" }
, { ftp_abor, "abor" }
, { ftp_stat, "stat" }
, { ftp_pwd, "pwd" }
, { ftp_pwd, "xpwd" }
, { ftp_cwd, "cwd" }
, { ftp_cwd, "xcwd" }
, { ftp_cdup, "cdup" }
, { ftp_cdup, "xcup" }
, { err_syst, "syst" }
, { err_anonymous, "pass" }
, { err_anonymous, "acct" }
, { err_allo, "allo" }
, { err_nowrite, "stor" }
, { err_nowrite, "stou" }
, { err_nowrite, "appe" }
, { err_nowrite, "dele" }
, { err_nowrite, "rnfr" }
, { err_nowrite, "rnto" }
, { err_nowrite, "mkd" }
, { err_nowrite, "xmkd" }
, { err_nowrite, "rmd" }
, { err_nowrite, "xrmd" }
, { 0, 0 }
};

void doit(cmd,over)
char *cmd;
int over;
{
 int i;
 int j;
 char ch;

 if (over) { err_toolong(); return; }

 for (i = 0;ftpcmd[i].fun;++i)
  {
   for (j = 0;ch = ftpcmd[i].text[j];++j)
     if ((cmd[j] != ch) && (cmd[j] != ch - 32))
       break;
   if (!ch)
     if (!cmd[j] || (cmd[j] == ' '))
      {
       while (cmd[j] == ' ') ++j;
       ftpcmd[i].fun(cmd[j] ? cmd + j : (char *) 0);
       return;
      }
  }
 err_dunno();
}
