#include <errno.h>
#include "err.h"
#include "out.h"

void err_init()
{ out("421 Sorry, major initialization error.\r\n"); }
void err_hi()
{ out("220 Hi there! This is anonftpd.\r\n"); }
void err_syst()
{ out("215 UNIX Type: L8\r\n"); }
void err_user()
{ out("230 Hi. No need to log in; I'm an anonymous ftp server.\r\n"); }
void err_aborted()
{ out("226 Okay, done with abort. No transfer in progress.\r\n"); }
void err_help()
{ out("214 The FTP protocol is documented in RFC 959 and RFC 1123.\r\n"); }
void err_bye()
{ out("221 Bye.\r\n"); }
void err_okay()
{ out("200 Okay.\r\n"); }
void err_noop()
{ out("200 I'm here.\r\n"); }
void err_struok()
{ out("200 Thanks, I always do file structure.\r\n"); }
void err_modeok()
{ out("200 Thanks, I always do stream mode.\r\n"); }
void err_ascii()
{ out("200 Why are you using ASCII?\r\n"); }
void err_typeok()
{ out("200 Okay, using binary.\r\n"); }
void err_updone()
{ out("200 Okay.\r\n"); }
void err_wddone()
{ out("250 Okay.\r\n"); }
void err_anonymous()
{
 out("202 I don't need account information; I'm an anonymous ftp server.\r\n");
}
void err_allo()
{ out("202 Why are you telling me? I don't allow file creation.\r\n"); }

void err_tryingdir()
{ out("150 I'm looking through the directory. Trying to connect...\r\n"); }
void err_tryingascii()
{ out("150 Warning: You're using ASCII! Trying to connect...\r\n"); }
void err_trying()
{ out("150 I see that file. Trying to connect...\r\n"); }
void err_waitingdir()
{ out("150 I'm looking through the directory. Waiting for connection...\r\n"); }
void err_waitingascii()
{ out("150 Warning: You're using ASCII! Waiting for connection...\r\n"); }
void err_waiting()
{ out("150 I see that file. Waiting for connection...\r\n"); }

void err_toolong()
{ out("500 Sorry, that line was too long.\r\n"); }
void err_noport()
{ out("501 What port did you want?\r\n"); }
void err_shortport()
{ out("501 Sorry, you need to give me six numbers separated by commas.\r\n"); }
void err_nofile()
{ out("501 What file do you want?\r\n"); }
void err_dunno()
{ out("502 Sorry, I don't understand that command.\r\n"); }
void err_transferring()
{ out("503 Slow down! I'm transferring data. Do you want to abort the transfer?\r\n"); }
void err_strubad()
{ out("504 Sorry, I don't do anything except file structure.\r\n"); }
void err_modebad()
{ out("504 Sorry, I don't do anything except stream mode.\r\n"); }
void err_typebad()
{ out("504 Sorry, I don't recognize that type.\r\n"); }
void err_statpath()
{ out("504 Sorry, I don't do file STATs.\r\n"); }
void err_porthost()
{ out("504 Sorry, that address is excluded for security reasons.\r\n"); }
void err_pwdio()
{ out("550 Sorry, I'm unable to figure out what directory you're in.\r\n"); }
void err_dirbad()
{ out("550 Sorry, I don't see that directory.\r\n"); }
void err_filebad()
{ out("550 Sorry, I don't see that file.\r\n"); }
void err_fileprot()
{ out("550 Sorry, that file isn't readable.\r\n"); }
void err_filenotreg()
{ out("550 Sorry, that isn't a data file.\r\n"); }
void err_filenotdir()
{ out("550 Sorry, that isn't a directory.\r\n"); }
void err_nowrite()
{ out("553 Sorry, I don't allow modification commands.\r\n"); }

void err_local()
{ out("451 Sorry, I've had a local error.\r\n"); }
void err_strange()
{ out("451 Sorry, I've had a strange error.\r\n"); }
void err_closing()
{ out("426 Closing data connection at your request.\r\n"); }
void err_trouble()
{ out("425 Sorry, I had trouble accepting that connection.\r\n"); }

void err_conn(e)
int e;
{
 switch(e)
  {
   case ETIMEDOUT:
     out("425 Data connection failed: nobody home!\r\n");
     break;
   case ECONNREFUSED:
     out("425 Data connection failed: refused by remote host!\r\n");
     break;
   case ECONNRESET:
     out("425 Data connection failed: reset!\r\n");
     break;
   case ENETRESET:
     out("425 Data connection failed: network reset!\r\n");
     break;
   case ENETDOWN:
     out("425 Data connection failed: network is down!\r\n");
     break;
   case ENETUNREACH:
     out("425 Data connection failed: network is unreachable!\r\n");
     break;
   case EHOSTDOWN:
     out("425 Data connection failed: host is down!\r\n");
     break;
   case EHOSTUNREACH:
     out("425 Data connection failed: host is unreachable!\r\n");
     break;
   case EPIPE:
     out("426 Hey, the data connection was closed!\r\n");
     break;
   default:
     out("426 Strange error on the data connection!\r\n");
  }
}
