#include "fmt6.h"
#include "fmt.h"

static char tr211[] = "211 transferred ";

static unsigned int fmtrn(s)
char *s;
{
 *s = '\r'; s[1] = '\n'; return 2;
}

unsigned int fmttrans1(s,n)
char *s;
int n;
{
 char *t;

 t = s + fmt_str(s,"226 Finished transferring ");
 t += fmt_uint(t,n);
 t += fmt_str(t," bytes.\r\n");
 return t - s;
}
unsigned int fmttrans2(s,n,n2)
char *s;
int n;
int n2;
{
 char *t;

 t = s + fmt_str(s,tr211);
 t += fmt_uint(t,n);
 t += fmt_str(t," out of ");
 t += fmt_uint(t,n2);
 t += fmtrn(t);
 return t - s;
}
unsigned int fmttrans3(s,n)
char *s;
int n;
{
 char *t;

 t = s + fmt_str(s,tr211);
 t += fmt_uint(t,n);
 t += fmtrn(t);
 return t - s;
}
unsigned int fmttrans4(s)
char *s;
{
 return fmt_str(s,"211 no transfer in progress\r\n");
}

unsigned int fmt227(s,h1,h2,h3,h4,p1,p2)
char *s;
int h1;
int h2;
int h3;
int h4;
int p1;
int p2;
{
 char *t;

 t = s + fmt_str(s,"227 =");
 t += fmt_uint(t,h1); *t++ = ',';
 t += fmt_uint(t,h2); *t++ = ',';
 t += fmt_uint(t,h3); *t++ = ',';
 t += fmt_uint(t,h4); *t++ = ',';
 t += fmt_uint(t,p1); *t++ = ',';
 t += fmt_uint(t,p2);
 t += fmtrn(t);
 return t - s;
}

static unsigned int fmthp(s,h1,h2,h3,h4,p)
char *s;
int h1; int h2; int h3; int h4; int p;
{
 char *t;
 t = s + fmt_uint(s,h1); *t++ = '.';
 t += fmt_uint(t,h2); *t++ = '.';
 t += fmt_uint(t,h3); *t++ = '.';
 t += fmt_uint(t,h4); *t++ = ':';
 t += fmt_uint(t,p); *t++ = ' ';
 return t - s;
}

unsigned int fmt211(s,uh1,uh2,uh3,uh4,up,th1,th2,th3,th4,tp,desc)
char *s;
int uh1; int uh2; int uh3; int uh4; int up;
int th1; int th2; int th3; int th4; int tp;
char *desc;
{
 char *t;
 t = s + fmt_str(s,"211-");
 t += fmthp(t,uh1,uh2,uh3,uh4,up);
 t += fmthp(t,th1,th2,th3,th4,tp);
 t += fmt_str(t,desc);
 t += fmtrn(t);
 return t - s;
}

unsigned int fmt211short(s,uh1,uh2,uh3,uh4,up,desc)
char *s;
int uh1; int uh2; int uh3; int uh4; int up;
char *desc;
{
 char *t;
 t = s + fmt_str(s,"211-");
 t += fmthp(t,uh1,uh2,uh3,uh4,up);
 t += fmt_str(t,desc);
 t += fmtrn(t);
 return t - s;
}

unsigned int fmteplf(s,dev,ino,time,flagcwd,flagretr,size)
char *s;
unsigned long dev;
unsigned long ino;
unsigned long time;
int flagcwd;
int flagretr;
unsigned long size;
{
 unsigned int len;
 char *t;

 t = s;
 t += fmt_str(t,"+i");
 t += fmt_ulong(t,dev);
 t += fmt_str(t,".");
 t += fmt_ulong(t,ino);
 t += fmt_str(t,",m");
 t += fmt_ulong(t,time); /* XXX: assuming that we're past 1970 */
 if (flagcwd)
   t += fmt_str(t,",/");
 if (flagretr)
  {
   t += fmt_str(t,",r,s");
   t += fmt_ulong(t,size);
  }
 t += fmt_str(t,",\t");
 return t - s;
}
