#include "telnet.h"
#include "doit.h"
#include "out.h"

char telnet_cmd[512];
#define cmd telnet_cmd
static int cmdstate = 0;
static int cmdlen = 0;
static int cmdover = 0;
static int telnetstate = 0;

static void feedcmd(ch)
int ch;
{
 if (ch == '\n')
  {
   cmd[cmdlen] = 0; doit(cmd,cmdover);
   cmdlen = 0; cmdstate = 0; cmdover = 0;
  }
 else
   if (cmdstate)
     cmdstate = 0;
   else
    {
     if (ch == '\r') cmdstate = 1;
     else
       if (cmdlen < sizeof(cmd) - 1) cmd[cmdlen++] = ch;
       else cmdover = 1;
    }
}

void telnet_feed(buf,buflen)
char *buf;
int buflen;
{
 char repl[4];
 int ch;

 while (buflen)
  {
   ch = (int) (unsigned int) (unsigned char) *buf;

   switch(telnetstate)
    {
     case 1: /* 255 ch */
       if (ch == 255) { feedcmd(ch); telnetstate = 0; }
       else if (ch == 254) telnetstate = 2;
       else if (ch == 253) telnetstate = 3;
       else if (ch == 252) telnetstate = 2;
       else if (ch == 251) telnetstate = 4;
       else telnetstate = 0;
       break;
     case 3: /* 255 253 ch */
       repl[0] = 255; repl[1] = 252; repl[2] = ch; repl[3] = 0;
       out(repl);
       telnetstate = 0;
       break;
     case 4: /* 255 251 ch */
       repl[0] = 255; repl[1] = 254; repl[2] = ch; repl[3] = 0;
       out(repl);
       telnetstate = 0;
       break;
     case 2: /* 255 254 ch or 255 252 ch */
       /* bormanesque stupidity; responding may cause a loop! */
       telnetstate = 0;
       break;
     default:
       if (ch == 255) telnetstate = 1;
       else feedcmd(ch);
       break;
    }

   ++buf;
   --buflen;
  }
}
